# Projet de Jeu d'Exploration en 2D

## Objectif du Projet

L'objectif de ce projet est de développer un jeu d'exploration de salles en 2D. Dans ce jeu, un personnage représentant le joueur navigue de salle en salle et de niveaux en niveaux. Les salles peuvent contenir des monstres et des objets, créant ainsi une expérience immersive et interactive.

## Fonctionnalités du Jeu

- **Navigation dans les Salles :** 
  - Le personnage joueur peut se déplacer de case en case dans un niveau.
  - Chaque niveau est entièrement visible à l'écran sans scrolling.
  - Les niveaux contiennent un ensemble de salles délimitées par des murs, chacune pouvant avoir une ou plusieurs entrées.

- **Objectif du Jeu :**
  - Le joueur doit trouver la sortie de chaque niveau pour passer au suivant.
  - Les salles peuvent contenir des objets, des pièges ou des monstres.

- **Mécanique de Jeu :**
  - Le jeu se joue au tour par tour : après l'action du joueur, les monstres visibles exécutent leur action (déplacement, attaque, etc.).
  - Le personnage joueur possède des caractéristiques telles que des points de vie et d'attaque, et peut ramasser et utiliser des objets.
  - Différents types de monstres apparaissent dans les salles, chacun ayant des comportements uniques.

- **Génération de Salles :**
  - Les salles peuvent être chargées à partir d'un fichier ou générées aléatoirement.
  - Dans le cas d'une génération aléatoire, un chemin vers la sortie sera toujours présent.

## Extensions Potentielles

- **Ajout de Nouveaux Monstres :** Intégration de nouveaux types de monstres avec des comportements variés.
- **Nouveaux Objets :** Ajout d'objets interactifs avec des effets spéciaux ou des capacités uniques.
- **Systèmes de Quêtes :** Mise en place de quêtes ou de missions pour enrichir l'expérience de jeu.
- **Multijoueur :** Développement d'un mode multijoueur où plusieurs joueurs peuvent explorer ensemble.

## Technologies Utilisées

- Langages de programmation : JAVA
- Bibliothèques et frameworks : JAVAX.SWING pour l'affichage graphique

## Auteurs

- Nilaina Razafindrambola
- Manda Rasoloson

## Licence

Ce projet est sous la licence MIT - voir le fichier [LICENSE](LICENSE) pour plus de détails.

