package controller;

import model.*;
import view.Fenetre;
import view.FenetreFin;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.SwingUtilities;

public class ListnerJoueur implements KeyListener{
    private Niveau niveau;
    private Fenetre fenetre;

    public ListnerJoueur(Niveau niveau, Fenetre fenetre) {
        // Ajout de l'écouteur de touches
        this.niveau = niveau;
        this.fenetre = fenetre;
        fenetre.setFocusable(true);
        fenetre.addKeyListener(this);
    }
    
    @Override
    public void keyPressed(KeyEvent e) {
        int status = -1;
        switch (e.getKeyCode()) {
            case KeyEvent.VK_UP:
                status = niveau.deplacerJoueur(1);
                fenetre.afficheAction("Monter");
                break;
            case KeyEvent.VK_DOWN:
                status = niveau.deplacerJoueur(3);
                fenetre.afficheAction("Descendre");
                break;
            case KeyEvent.VK_LEFT:
                status = niveau.deplacerJoueur(4);
                fenetre.afficheAction("Gauche");
                break;
            case KeyEvent.VK_RIGHT:
                status = niveau.deplacerJoueur(2);
                fenetre.afficheAction("Droite");
                break;
            default:
                break;
        }
        // -1 : rien a ete fait
        // 0 : moouvement reussi
        // 1 : attaque monstre
        // 2 : tomber dans un piege
        // 3 : entree
        // 4 : sortie
        // 5 : mort
        // 6 : potion
        switch (status) {
            case 1:
                // fenetre.message("Fight, be the winner !");
                fenetre.afficheAction("Attaque du monstre");
                break;
            
            case 2:
                // fenetre.message("Tomber dans un piege PV -20");
                fenetre.afficheAction("Tomber dans un piege PV -20");
                break;

            case 3:
                fenetre.message("Non, Il faut avancer Chevalier "+niveau.getJoueur().getNom());
                break;

            case 4:
                fenetre.message("Felicitation Chevalier "+niveau.getJoueur().getNom()+", niveau suivant !");
                niveau.niveauTerminer();
                break;

            case 5:
                fenetre.gameOver();
                niveau.niveauTerminer();
                 // Création d'une instance de FenetreFin
                SwingUtilities.invokeLater(new Runnable() {
                    public void run() {
                        new FenetreFin("Vous etes mort minablement "+niveau.getJoueur().getNom());
                    }
                });
                break;

            case 6:
                fenetre.afficheAction("++ Potion ++");
                break;
        
            default:
                break;
        }
        fenetre.updateGrille();
        fenetre.affichePv();
    }
    
    @Override
    public void keyReleased(KeyEvent e) {
        // Not used
    }

    @Override
    public void keyTyped(KeyEvent e) {
        // Not used
    }

    public void setNiveau(Niveau niveau){
        this.niveau = niveau;
    }
    
}
