package model;

import java.util.List;
import java.util.ArrayList;
import java.util.Random;

public class Joueur extends Item{

	private List<Item> sac = new ArrayList<Item>();
	private int vie = 100;
	public Joueur(String nom, Position position) {
		this.setNom(nom);
		this.setPosition(position);
	}
	
	public Joueur(String nom) {
		this.setNom(nom);
	}
	
	public Joueur() {
		this("Player one");
	}
	
	public int getVie() {
        return vie;
    }
	
	public void setVie(int pointsDeVie) {
        this.vie = pointsDeVie;
    }
	public void perdrePointsDeVie(int vie) {
        this.vie -= vie;
        if (this.vie < 0) {
            this.vie = 0;
        }
    }
	
	public void addVie() {
		this.vie+=5;
	}
	
	public void attaquerMonstre(Monstre m, Grille grille) {
		Monstre.diminuerNombreMonstre();
		grille.getCarte()[m.getPosition().getY()][m.getPosition().getX()] = null;
	}
	@Override
	public String toString() {
		return "Joueur [Nom=" + getNom() + "]";
	}

	public boolean estVivant() {
		return this.vie>0;
	}

	// 1=haut, 2=droite, 3=bas, 4=gauche
	public Position bougerVers(int direction) {
		if (direction == 1) {
			return new Position(this.getPosition().getX(), this.getPosition().getY()-1);
		} else if (direction == 2) {
			return new Position(this.getPosition().getX()+1, this.getPosition().getY());
		} else if (direction == 3) {
			return new Position(this.getPosition().getX(), this.getPosition().getY()+1);
		} else if (direction == 4) {
			return new Position(this.getPosition().getX()-1, this.getPosition().getY());
		} else {
			return this.getPosition();
		}
	}

	public int prendrePotion(Potion potion){
		vie += potion.getPlusVie();
		return potion.getPlusVie();
	}

	public void ajouteObjet(Item item){
		this.sac.add(item);
	}
}