package model;

import java.util.Random;

public class Monstre extends Item {
	private static final int Puissance = 10;
	private static final int chance_attaque = 30;
	private static final Random rand = new Random();
	private static int nombreDeMonstre = 0;

	public static int getNombreDeMonstre() {
		return nombreDeMonstre;
	}

	public static void setNombreDeMonstre(int nombreDeMonstre) {
		Monstre.nombreDeMonstre = nombreDeMonstre;
	}

	public static void diminuerNombreMonstre() {
		nombreDeMonstre--;
	}

	public Monstre(String nom, Position position) {
		this.setNom(nom);
		this.setPosition(position);
		nombreDeMonstre++;
	}

	public Monstre(String nom) {
		this.setNom(nom);
		nombreDeMonstre++;
	}

	public Monstre() {
		this("Player one");
	}

	public void deplacerMonstre(Grille grille) {
	    int row = this.getPosition().getY();
	    int col = this.getPosition().getX();
	    int dir = rand.nextInt(4);
	    int newRow = row;
	    int newCol = col;

	    switch (dir) {
	        case 0: // Haut
	            newRow--;
	            break;
	        case 1: // Bas
	            newRow++;
	            break;
	        case 2: // Gauche
	            newCol--;
	            break;
	        case 3: // Droite
	            newCol++;
	            break;
	        default:
	            break;
	    }
	    
//	    System.out.println(newCol);
//	    System.out.println(newRow);
//	    System.out.println();
	    if (newRow >= 0 && newRow < grille.getLongueur() && newCol >= 0 && newCol < grille.getLargeur()) {
	        if (grille.estVide(newCol, newRow) && !grille.estMur(newRow, newCol) && !grille.estPiege(newRow, newCol) && !grille.estLeJoueur(newRow, newCol) && !grille.estMonstre(newRow, newCol)){
	            this.setPosition(new Position(newCol, newRow));
	            grille.getCarte()[row][col]=null;
	            grille.getCarte()[newRow][newCol]=this;
	          
	            
	        } else if (grille.estLeJoueur(newCol, newRow)) {
	            Joueur joueur = grille.getJoueur();
	            this.attaquerJoueur(joueur);
	        }
	    }
	}


	public void attaquerJoueur(Joueur joueur) {
		int chanceAttaque = rand.nextInt(100);

		if (chanceAttaque < chance_attaque) {
			joueur.perdrePointsDeVie(Puissance);
			if (joueur.getVie() <= 0) {
				System.out.println("GAME OVER!");
				System.exit(0);
			} else {
				System.out.println(
						"Le monstre vous a attaqué ! Vous avez maintenant " + joueur.getVie() + " points de vie.");
			}
		} else {
			System.out.println("Le monstre a essayé de vous attaquer mais a manqué !");
		}
	}

	@Override
	public String toString() {
		return "Monstre [Nom=" + getNom() + "]";
	}
}
