package view;
import javax.swing.*;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.IOException;
import javax.imageio.ImageIO;

public class Case extends JPanel {
    private static final long serialVersionUID = 1L;
    private String type = "Vide";
    private JLabel imageLabel;
    private static ImageIcon monstreIcon;
    private static ImageIcon joueurIcon;
    private static ImageIcon murIcon;
    private static ImageIcon trapIcon;
    private static ImageIcon coeurIcon;
    private static ImageIcon potionIcon;

    static {
        try {
            BufferedImage monstreImg = ImageIO.read(Case.class.getResource("monstre.png"));
            monstreIcon = new ImageIcon(monstreImg.getScaledInstance(20, 20, Image.SCALE_SMOOTH));

            BufferedImage joueurImg = ImageIO.read(Case.class.getResource("joueur.png"));
            joueurIcon = new ImageIcon(joueurImg.getScaledInstance(40, 40, Image.SCALE_SMOOTH));

            BufferedImage murImg = ImageIO.read(Case.class.getResource("mur.png"));
            murIcon = new ImageIcon(murImg.getScaledInstance(40, 40, Image.SCALE_SMOOTH));
            
            BufferedImage trapImg = ImageIO.read(Case.class.getResource("trap.png"));
            trapIcon = new ImageIcon(trapImg.getScaledInstance(30, 30, Image.SCALE_SMOOTH));
            
            BufferedImage coeurImg = ImageIO.read(Case.class.getResource("heart.png"));
            coeurIcon = new ImageIcon(coeurImg.getScaledInstance(20, 20, Image.SCALE_SMOOTH));
            
            BufferedImage potionImg = ImageIO.read(Case.class.getResource("potion.png"));
            potionIcon = new ImageIcon(potionImg.getScaledInstance(20, 20, Image.SCALE_SMOOTH));
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public Case(String type) {
        this.setPreferredSize(new Dimension(40, 40));
        imageLabel = new JLabel();
        add(imageLabel);
        setType(type);
    }

    public void setType(String type) {
        this.type = type;
        switch (type) {
            case "Monstre":
                imageLabel.setIcon(monstreIcon);
                break;
            case "Joueur":
                imageLabel.setIcon(joueurIcon);
                break;
            case "Mur":
                imageLabel.setIcon(murIcon);
                break;
            case "Piege":
                imageLabel.setIcon(trapIcon);
                break;
            case "Vie":
                imageLabel.setIcon(coeurIcon);
                break;
            case "Potion":
                imageLabel.setIcon(potionIcon);
                break;
                
            default:
                imageLabel.setIcon(null);
                break;
        }
    }
}
